SystemOrganization addCategory: #ManifestoBrowser!

Object subclass: #LintRuleBrowser
	instanceVariableNames: 'head tree browser environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ManifestoBrowser'!

!LintRuleBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/4/2011 12:41'!
for: tree
	^self for:tree onEnvironment: BrowserEnvironment new! !

!LintRuleBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/4/2011 12:38'!
for: tree onEnvironment: env
	^self new tree:tree environment: env! !

!LintRuleBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 14:06'!
formatTree: a
	^a tree 
			title: 'Lint-Check Rules'; 
			children: [ :x :i | x isLeaf ifTrue: [OrderedCollection new] ifFalse: [ x children ] ];
			rootsExpanded; 
			format: [ :node | self nodeDisplayName: node ];
			icon: [:node | self nodeDisplayIcon: node ];
			beMultiple;
			"act: [:p | p selection inspect ] icon: UITheme current smallInspectItIcon entitled: 'Inspect'; "
			act: [:p | p selection ifNotNilDo: [:sel | sel do: [:each| tree remove: each]]. browser update ] icon: UITheme current smallDeleteIcon entitled: 'Remove';
			act: [:p | self openAddRuleDialog ] icon: UITheme current smallRightFlushIcon entitled: 'Add rules';
			act: [:p | p selection ifNotNilDo: [:sel | self runLint: sel ]] icon: UITheme current smallForwardIcon  entitled: 'Run rules'! !

!LintRuleBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/5/2011 15:51'!
nodeDisplayIcon: node
	^node analized 
				ifTrue: [ node allAnalized 
							ifTrue: [ node problemCount = 0 
										ifTrue: UITheme current smallOkIcon  
										ifFalse: UITheme current smallErrorIcon
									]
							ifFalse: [ node problemCount > 0 ifTrue: [UITheme current smallErrorIcon] ]]! !

!LintRuleBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/5/2011 15:51'!
nodeDisplayName: node
	^node name , ' ', 
	(node analized 
			ifTrue: '(',node problemCount printString, (node allAnalized ifTrue:[''] ifFalse:[' partially']),')' 
			ifFalse: '')! !

!LintRuleBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/5/2011 23:50'!
open
	"(LintRuleBrowser for:(LintRuleTree for: RBCompositeLintRule lintChecks) onEnvironment: (BrowserEnvironment new forPackageNames: #('Mondrian-Core'))) open"

	browser := GLMTabulator new.	
	browser title: self title.
	browser 
		column: #rules;
		column: #preview. 
		
	browser transmit to: #rules; andShow: [ :a | 
		self formatTree: a].
		      
	browser transmit to: #preview; from: #rules; andShow: [ :a |
		a text
			when: [:x| (x size = 1) and: ((x atWrap:1) isLeaf )];
			display: [ :x | ((x atWrap:1) rule asNode update: (BrowserEnvironment new)) text] ].
		
	browser openOn: tree head children! !

!LintRuleBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/5/2011 15:56'!
openAddRuleDialog

	| finder validator |
	
	finder := GLMFinder new.
	validator := GLMValidator new.
	validator show: [:a | 
		a tree 
			title: 'Lint-Check Rules';
			beMultiple; 
			children: [ :node :i | node isLeaf ifTrue:[OrderedCollection new] ifFalse: [ node children  ] ];
			rootsExpanded; 
			format: [ :node | node name ]].
	validator validator: 'Ok' act: [:x | x selection ifNotNilDo: [:sel | tree addNodes: sel]. x close. browser update ].
		
	finder show: [:a | a custom: validator].
	finder openOn: ((LintRuleTree for: (RBCompositeLintRule lintChecks)) removeNodesIn:tree) head children! !

!LintRuleBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/5/2011 15:11'!
runLint: selectedNodes
	SmalllintChecker 
						runRule: (RBCompositeLintRule rules: (selectedNodes collect:[:each | each toRule ])) 
						onEnvironment: environment. selectedNodes do: [:each | each analized:true]. 
					browser update! !

!LintRuleBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/4/2011 16:13'!
title
	^'Lint Browser for ',(environment packages collect:[:each | each packageName ]) asCommaString! !

!LintRuleBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 21:21'!
tree
	^tree! !

!LintRuleBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 21:25'!
tree:t
	tree:= t.
	^ self! !

!LintRuleBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/4/2011 12:38'!
tree:t environment: env
	tree:= t.
	environment  := env.
	^ self! !

LintRuleBrowser subclass: #LintRulePackageBrowser
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ManifestoBrowser'!

!LintRulePackageBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/5/2011 23:46'!
forPackageName: n
	^self new package: n ! !

!LintRulePackageBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 14:05'!
formatTree: a
	^(super formatTree: a) act: [:p | self saveTree ] icon: UITheme current smallSaveIcon  entitled: 'Save tree'! !

!LintRulePackageBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 15:36'!
package: packageName
	| pack t |
	package := packageName.
	
	pack := RPackageOrganizer default packageNamed: packageName.
	(ManifestoBrowser hasManisfesto: pack)
		ifTrue:  [(ManifestoBrowser manifestoOf: pack) ruleTree
					ifNil: [(ManifestoBrowser manifestoOf: pack) ruleTree: (LintRuleTree for: RBCompositeLintRule lintChecks)].
				 t := (ManifestoBrowser manifestoOf: pack) ruleTree].
	
	t ifNil: [ t:= (LintRuleTree for: RBCompositeLintRule lintChecks)].
	
	^ super
		tree: t veryDeepCopy
		environment: (BrowserEnvironment new forPackageNames: (Array with: packageName))! !

!LintRulePackageBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 15:36'!
saveTree
	| pack t |
	pack := RPackageOrganizer default packageNamed: package.
	(ManifestoBrowser hasManisfesto: pack)
		ifFalse: [ ManifestoBrowser createManifesto: package ].
		
	(ManifestoBrowser manifestoOf: pack) ruleTree: tree! !

Object subclass: #LintRuleNode
	instanceVariableNames: 'name children rule analized parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ManifestoBrowser'!

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 23:47'!
addChild: node
	children ifNil: [children := LinkedList new].
	children add: node.
	node parent:self! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 23:32'!
allAnalized
	self isLeaf ifTrue: [analized isNil ifTrue: [^false] ifFalse: [^analized]] ifFalse:[children do:[: each | each analized ifFalse: [^false]]. ^true]  ! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 23:01'!
allRules
	| allRules |
	self isLeaf ifTrue: [^Array with: self rule] ifFalse:[ allRules := LinkedList new. children do: [:each| each allRules do: [:each2 | allRules add: each2]]. ^allRules]! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 23:30'!
analized
	self isLeaf ifTrue: [analized isNil ifTrue: [^false] ifFalse: [^analized]] ifFalse:[children do:[: each | each analized ifTrue: [^true]]. ^false]  ! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 23:27'!
analized: v
	self isLeaf ifTrue: [analized := v] ifFalse:[
	children do:[:each | each analized:v]]! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 21:15'!
children
	^children! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/5/2011 15:39'!
isLeaf
	"^children isNil ifTrue:[true] ifFalse:[children isEmpty]"
	^children isNil! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/1/2011 10:06'!
leaves
	| leaves |
	leaves := LinkedList new.
	self isLeaf ifTrue: [leaves add: self] ifFalse: [
		self children do:[:each | each leaves do:[:each2| leaves add: each2]]
		].
	^leaves! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 21:14'!
name
	^name! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 21:14'!
name: s
	name := s! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/1/2011 09:16'!
parent
	^parent! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 23:48'!
parent: node
	parent := node! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 23:35'!
problemCount
	| count |
	self isLeaf ifTrue: [^self rule problemCount ] ifFalse: [count := 0. children do: [:each | count := count + each problemCount]. ^count]! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/5/2011 10:32'!
remove: node
	self isLeaf 
		ifFalse:[
			children remove: node ifAbsent: [ children do: [:each | each remove: node]].
			children isEmpty ifTrue:[parent ifNotNilDo: [:p | p remove:self]]
		]! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/5/2011 10:30'!
removeNamed:  aName
	self isLeaf 
		ifFalse:[
			children removeAllSuchThat: [:each | (each name compare: aName) = 2]. 
			children do: [:each | each removeNamed: aName].
			children isEmpty ifTrue:[parent ifNotNilDo: [:p | p remove:self]]
		]! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 22:11'!
rule
	^rule! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 22:12'!
rule: r
	rule := r! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 23:03'!
toRule

	^ RBCompositeLintRule rules: self allRules! !

Object subclass: #LintRuleTree
	instanceVariableNames: 'head'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ManifestoBrowser'!

!LintRuleTree class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/5/2011 15:54'!
for: rule
	| node |
	node := LintRuleNode new name: 'Dummy'.
	node addChild: (self toNode: rule).
	^self new head: node! !

!LintRuleTree class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 22:12'!
toNode: rule
	| node |
	node := LintRuleNode new name: rule name.
	rule isComposite ifTrue:[ rule rules do: [:each | node addChild: (self toNode: each)]] ifFalse: [ node rule: rule].
	^ node.! !

!LintRuleTree methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/1/2011 10:28'!
addNodes: nodes
	nodes do: [:each | 
		(self searchNamed: each parent name) ifNil: [
		|n parent | n := (self searchNamed: each parent parent name).
		 parent := LintRuleNode new name: each parent name.
		 parent addChild: each.
		 n addChild: parent

		] ifNotNilDo: [:n | n addChild: each] ]! !

!LintRuleTree methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 21:14'!
head
	^head! !

!LintRuleTree methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 21:13'!
head: node
	head := node! !

!LintRuleTree methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/1/2011 09:58'!
leaves
	^head leaves! !

!LintRuleTree methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 21:47'!
remove: node
	head remove: node! !

!LintRuleTree methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/5/2011 15:33'!
removeNamed: aName
	head removeNamed: aName! !

!LintRuleTree methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/1/2011 10:14'!
removeNodesIn: aTree
	| leaves |
	leaves := aTree leaves.
	
	leaves do:[:each| self removeNamed: each name].
	^self 
	! !

!LintRuleTree methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/1/2011 09:07'!
searchNamed: name
	
	^self searchNamed: name in:head! !

!LintRuleTree methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/1/2011 09:49'!
searchNamed: name in: node
	
	| v |
	((node name compare: name) = 2)
		ifTrue: [^node] 
		ifFalse: [ node isLeaf 
			ifFalse: [node children do: [:each | v := self searchNamed: name in: each. v ifNotNilDo: [:n|^v]]]].
	^nil. ! !

Object subclass: #ManifestoBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ManifestoBrowser'!

!ManifestoBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 14:49'!
createManifesto: packageName

	| package cls |
	
	package := (RPackageOrganizer default packageNamed: packageName).
	
	
	cls := (Object subclass: (ManifestoBrowser manifestoNameOfPackageNamed: packageName) asSymbol 
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: packageName
	).
	
	cls class instanceVariableNames: 'tree packageDescription'.
	cls class compile: 'ruleTree: t
					tree := t'.
					
	cls class compile: 'ruleTree 
					^tree'.
	
	cls class compile: 'packageDescription: d
					packageDescription := d'.
					
	cls class compile: 'packageDescription 
					^packageDescription'.! !

!ManifestoBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 15:36'!
hasManisfesto: aPackage
	"this should be an extension method dfined on the class RPackage"
	
	| manisfestoName |
	manisfestoName := self manifestoNameOf: aPackage.
	^ aPackage classes anySatisfy: [ :aClass | aClass name = manisfestoName ]! !

!ManifestoBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/5/2011 14:53'!
icon
! !

!ManifestoBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 15:36'!
manifestoNameOf: aPackage

	^ 'Manifesto', (aPackage name copyWithout: $-)! !

!ManifestoBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 12:03'!
manifestoNameOfPackageNamed: packageName

	^ 'Manifesto', (packageName copyWithout: $-)! !

!ManifestoBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 15:36'!
manifestoOf: aPackage

	^ Compiler evaluate: (self manifestoNameOf: aPackage)! !

!ManifestoBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/5/2011 15:57'!
menuCommandOn: aBuilder
	<worldMenu>

	(aBuilder item: #'ManifestoBrowser')
		order: 6; 
		parent: #Tools;
		label: 'Manifesto Browser';
		"icon: self icon;"
		action:[ManifestoBrowser open]! !

!ManifestoBrowser class methodsFor: 'public' stamp: 'AngelNunez 9/28/2011 13:43'!
open
	"Open a browser"
	^ self new open! !

!ManifestoBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 14:29'!
authors: x
	|s| 
	^(((RPackageOrganizer default packageNamed: (x)) methods  
								collect: [ :cm| s := cm timeStamp substrings. s isEmpty ifTrue:[''] ifFalse:[ s first ]]) asSet)! !

!ManifestoBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 15:36'!
description: packageName
	| package | 
	
	package := RPackageOrganizer default packageNamed: packageName.
	
	^(ManifestoBrowser hasManisfesto: package) 
		ifTrue: [(ManifestoBrowser manifestoOf: package) packageDescription ifNil: [''] ifNotNilDo:[:d|d] ] 
		ifFalse:['']! !

!ManifestoBrowser methodsFor: 'opening' stamp: 'AngelNunez 9/28/2011 14:06'!
open
	"
	self new open
	"

	^ self openOn: self sortedPackages! !

!ManifestoBrowser methodsFor: 'opening' stamp: 'AngelNunez 10/6/2011 15:10'!
openOn: aPackageList
	"
	self new open
	"
	| browser |
	
	browser := GLMTabulator new.
	browser title: 'Manifesto Browser'.
	browser 
		column: #packages; 
		column: #manifesto.
	
	browser transmit to: #packages;andShow: [ :a | a list
		title: 'Package';
		"searchOn: [:text :each | (Compiler evaluate: '[:each | ''', text ,''' match: each]') value: each];"
		beSingle;
		act: [:x |
			x selection ifNotNilDo: [:packageName | (LintRulePackageBrowser forPackageName: packageName ) open ]] 
		icon: GLMUIThemeExtraIcons glamorousInto entitled: 'Open Lint Browser'.].
		
	browser transmit 
		to: #manifesto; 
		from: #packages; 
		andShow: [ :a | 
			a stackedVerticallyArrangement.
			a list title: 'Authors';
				display: [ :x | self authors: x ].
			a text title: 'Description';
				display: [:x| self description: x ];
				act: [:x | self saveDescription:x entity description: x text ] 
				icon: UITheme current smallSaveIcon  entitled: 'Save description' ].
	
	browser openOn: (aPackageList collect:[:each | each name])! !

!ManifestoBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 11:37'!
packageContent: x
	|s| 
	^'Package ', x,
							String cr, Character cr asString,
							'Author:', Character cr asString, Character cr asString,
							(((RPackageOrganizer default packageNamed: (x)) methods  
								collect: [ :cm| s := cm timeStamp substrings. s isEmpty ifTrue:[''] ifFalse:[ s first ]]) asSet asCommaString),
							Character cr asString, Character cr asString,
							'Description:', Character cr asString, Character cr asString! !

!ManifestoBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 15:36'!
saveDescription: packageName description: description
	| pack t |
	pack := RPackageOrganizer default packageNamed: packageName.
	(ManifestoBrowser hasManisfesto: pack)
		ifFalse: [ ManifestoBrowser createManifesto: packageName ].
		
	(ManifestoBrowser manifestoOf: pack) packageDescription: description! !

!ManifestoBrowser methodsFor: 'util' stamp: 'AngelNunez 9/28/2011 14:06'!
sortedPackages
	^ RPackageOrganizer default packages asSortedCollection: [ :a :b | a name <= b name ]! !

Object subclass: #ManifestoManifestoBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ManifestoBrowser'!

ManifestoManifestoBrowser class
	instanceVariableNames: 'tree packageDescription'!

ManifestoManifestoBrowser class
	instanceVariableNames: 'tree packageDescription'!

!ManifestoManifestoBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 15:46'!
packageDescription 
					^packageDescription! !

!ManifestoManifestoBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 15:46'!
packageDescription: d
					packageDescription := d! !

!ManifestoManifestoBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 15:46'!
ruleTree 
					^tree! !

!ManifestoManifestoBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 15:46'!
ruleTree: t
					tree := t! !

TestCase subclass: #ManifestoBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ManifestoBrowser'!

!ManifestoBrowserTest methodsFor: 'util' stamp: 'AngelNunez 9/28/2011 14:27'!
packageName
	^ 'ManifestoBrowser'! !

!ManifestoBrowserTest methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 15:36'!
testHasManisfesto

	| aPackage browser |
	browser := ManifestoBrowser new.

	aPackage := (RPackageOrganizer default packageNamed: self packageName).
	self assert: (browser hasManisfesto: aPackage).

	aPackage := (RPackageOrganizer default packageNamed: 'Kernel-Classes').
	self deny: (browser hasManisfesto: aPackage).
! !

!ManifestoBrowserTest methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 15:36'!
testManisfestoName

	| browser aPackage |
	browser := ManifestoBrowser new.
	aPackage := RPackageOrganizer default packageNamed: 'Kernel-Classes'.
	self assert: (browser manifestoNameOf: aPackage) = 'ManifestoKernelClasses'.
	
	aPackage := RPackageOrganizer default packageNamed: 'Announcements-Tests-Core'.
	self assert: (browser manifestoNameOf: aPackage) = 'ManifestoAnnouncementsTestsCore'! !
